package models

import "encoding/xml"

type ReportListEnvelope struct {
	XMLName xml.Name       `xml:"soap:Envelope"`
	Soap    string         `xml:"xmlns:soap,attr"`
	Xsi     string         `xml:"xmlns:xsi,attr"`
	Xsd     string         `xml:"xmlns:xsd,attr"`
	Body    ReportListBody `xml:"soap:Body"`
}

type ReportListBody struct {
	XMLName      xml.Name     `xml:"soap:Body"`
	GetReportReq GetReportReq `xml:"GetAllSampleList"`
}

type GetReportReq struct {
	XMLName       xml.Name `xml:"http://tempuri.org/ GetAllSampleList"`
	Key           string   `xml:"key"`
	BeginDateTime string   `xml:"BeginDateTime"`
	EndDateTime   string   `xml:"EndDateTime"`
	DateType      int      `xml:"DateType"`
	PrintState    int      `xml:"PrintState"`
}

type EnvelopeTwo struct {
	XMLName xml.Name     `xml:"http://schemas.xmlsoap.org/soap/envelope/ Envelope"`
	Body    EnvelopeBody `xml:"Body"`
}

type EnvelopeBody struct {
	GetAllSampleListResponse GetAllSampleListResponse `xml:"GetAllSampleListResponse"`
}

type GetAllSampleListResponse struct {
	XMLName                xml.Name `xml:"http://tempuri.org/ GetAllSampleListResponse"`
	GetAllSampleListResult string   `xml:"GetAllSampleListResult"`
}

type ReportData struct {
	Res                    int                      `json:"Res"`
	Error                  string                   `json:"Error"`
	GPReportListResultData []GPReportListResultData `json:"Data"`
}

type GPReportListResultData struct {
	RecordID           string `json:"RecordID"`
	PatientName        string `json:"PatientName"`
	Sex                string `json:"Sex"`
	Age                int    `json:"Age"`
	AgeUnit            string `json:"AgeUnit"`
	OfficeName         string `json:"OfficeName"`
	BedCode            string `json:"BedCode"`
	Barcode            string `json:"Barcode"`
	CustomerBarcode    string `json:"CustomerBarcode"`
	SampleCode         string `json:"SampleCode"`
	SampleCategory     string `json:"SampleCategory"`
	SampleDescription  string `json:"SampleDescription"`
	Diagnostics        string `json:"Diagnostics"`
	TakeSampleDateTime string `json:"TakeSampleDateTime"`
	ReceiveDateTime    string `json:"ReceiveDateTime"`
	AuditDateTime      string `json:"AuditDateTime"`
	InspectDate        string `json:"InspectDate"`
	SendDoctor         string `json:"SendDoctor"`
	InspectDoctorName  string `json:"InspectDoctorName"`
	AuditorName        string `json:"AuditorName"`
	Instrument         string `json:"Instrument"`
	Comment            string `json:"Comment"`
}
