package models

import "encoding/xml"

type ReportResultEnvelope struct {
	XMLName xml.Name         `xml:"soap:Envelope"`
	Soap    string           `xml:"xmlns:soap,attr"`
	Xsi     string           `xml:"xmlns:xsi,attr"`
	Xsd     string           `xml:"xmlns:xsd,attr"`
	Body    ReportResultBody `xml:"soap:Body"`
}

type ReportResultBody struct {
	XMLName            xml.Name           `xml:"soap:Body"`
	GetReportResultReq GetReportResultReq `xml:"GetJSONReportItemListByCustomerBarocde"`
}

type GetReportResultReq struct {
	XMLName         xml.Name `xml:"http://tempuri.org/ GetJSONReportItemListByCustomerBarocde"`
	Key             string   `xml:"key"`
	CustomerBarCode string   `xml:"CustomerBarCode"`
}

type EnvelopeThree struct {
	XMLName xml.Name          `xml:"http://schemas.xmlsoap.org/soap/envelope/ Envelope"`
	Body    EnvelopeBodyThree `xml:"Body"`
}

type EnvelopeBodyThree struct {
	GetJSONReportItemListByCustomerBarocdeResponse GetJSONReportItemListByCustomerBarocdeResponse `xml:"GetJSONReportItemListByCustomerBarocdeResponse"`
}

type GetJSONReportItemListByCustomerBarocdeResponse struct {
	XMLName                                      xml.Name `xml:"http://tempuri.org/ GetJSONReportItemListByCustomerBarocdeResponse"`
	GetJSONReportItemListByCustomerBarocdeResult string   `xml:"GetJSONReportItemListByCustomerBarocdeResult"`
}

type ReportResultData struct {
	Res           int             `json:"Res"`
	Error         string          `json:"Error"`
	InspectResult []InspectResult `json:"Data"`
}

type InspectResult struct {
	ChargeItemName string `json:"ChargeItemName"`
	InspectionName string `json:"InspectionName"`
	InspectionCode string `json:"InspectionCode"`
	Result         string `json:"Result"`
	Reference      string `json:"Reference"`
	Barcode        string `json:"Barcode"`
	Unit           string `json:"Unit"`
	Flag           string `json:"Flag"`
	intFlag        int    `json:"intFlag"`
	ListResult     GPReportListResultData
}
