package models

import "encoding/xml"

type GPReportResultEnvelope struct {
	XMLName xml.Name           `xml:"soap:Envelope"`
	Soap    string             `xml:"xmlns:soap,attr"`
	Xsi     string             `xml:"xmlns:xsi,attr"`
	Xsd     string             `xml:"xmlns:xsd,attr"`
	Body    GPReportResultBody `xml:"soap:Body"`
}

type GPReportResultBody struct {
	XMLName            xml.Name             `xml:"soap:Body"`
	GetReportResultReq GetGPReportResultReq `xml:"GetJSONReportItemListByGPBarocde"`
}

type GetGPReportResultReq struct {
	XMLName   xml.Name `xml:"http://tempuri.org/ GetJSONReportItemListByGPBarocde"`
	Key       string   `xml:"key"`
	GPBarCode string   `xml:"GPBarCode"`
}

type EnvelopeFive struct {
	XMLName xml.Name         `xml:"http://schemas.xmlsoap.org/soap/envelope/ Envelope"`
	Body    EnvelopeBodyFive `xml:"Body"`
}

type EnvelopeBodyFive struct {
	GetJSONReportItemListByGPBarocdeResponse GetJSONReportItemListByGPBarocdeResponse `xml:"GetJSONReportItemListByGPBarocdeResponse"`
}

type GetJSONReportItemListByGPBarocdeResponse struct {
	XMLName                                xml.Name `xml:"http://tempuri.org/ GetJSONReportItemListByGPBarocdeResponse"`
	GetJSONReportItemListByGPBarocdeResult string   `xml:"GetJSONReportItemListByGPBarocdeResult"`
}

type ReportResultDataFive struct {
	Res           int                 `json:"Res"`
	Error         string              `json:"Error"`
	InspectResult []InspectResultFive `json:"Data"`
}

type InspectResultFive struct {
	ChargeItemName string `json:"ChargeItemName"`
	InspectionName string `json:"InspectionName"`
	InspectionCode string `json:"InspectionCode"`
	Result         string `json:"Result"`
	Reference      string `json:"Reference"`
	Barcode        string `json:"Barcode"`
	Unit           string `json:"Unit"`
	Flag           string `json:"Flag"`
	IntFlag        int    `json:"intFlag"`
	ListResult     GPReportListResultData
}
